package clad;
// package EDU.auburn.VGJ.nesting;


//import EDU.auburn.VGJ.gui.*;

/*created sept 12, 2000
 *by Jake Derington
 *
 */
import clad.*;

//import java.awt.*;
//import java.awt.event.*;

//import java.io.*;

import java.util.Vector;

//import javax.swing.*;
//import javax.swing.event.*;
//import javax.swing.text.*;


public class Nesting
{

	public dna dnac;
	public int debug                 = 0x01;  //0x90=debug //0x01 goodstuff
	public int big                   = 1000000;

	//public Vector components = new Vector();
	public Vector namel              = new Vector();
	public Vector orderName;
	public Vector linkl              = new Vector();
	public Vector tempName           = new Vector();

	//public TextOutputStream logfile;
	public TextOutputStream logfile;


	public Nesting(dna tdna, String nestFile)
	{
		dnac = tdna;
		//get a filename...
		logfile = new TextOutputStream(nestFile);

		if (dnac == null)
		{
			dprintln("this is a null dna pointer?");
			//			System.out.println(" may want to allow this to be run from info in file...");
		}
	}


	public void run(int LEVELS)
	{

		TaxaItem tempt;
		TaxaItem tempt2;
		TaxaItem nboritem;
		NameList tempNL;
		NameList tempNL2;
		NameList tempN1;
		NameList tempN2;
		NameList tempname;
		NameList tempNL3;
		LinkList tempLL;
		LinkList tempL1;
		LinkList tempL2;
		LinkList tempL3;
		LinkList tempL4;
		int level          = 1;  //this is incremented after each level
		int group          = 1;  //a unique identifier that is incre w/ each group creation
		int levelid        = 1;  //this is reset to 1 for each level

		//int groupcnt = 0;
		int grsize         = big;
		int grPos          = 0;
		int grID           = 0;
		int dups           = 0;
		int inter          = 0;
		int grindiv        = 0;
		//		dprintln("this is my attempt at finding neighbors");

		int i              = 0;
		int j              = 0;
		int num            = 0;
		int nl             = 0;
		int num3           = 0;
		int gr             = 0;
		int gnum           = 0;
		int num2           = dnac.alltaxa.size();  //components.size();
		//		dprintln("enum1 # of elements " + num2);

		while (i < num2)
		{  //Create the name list for all nodes

			inter = 0;
			tempt = (TaxaItem) dnac.alltaxa.elementAt(i);
			num = tempt.nbor.size();  //may want to remove nodes without neighbors
			dups = tempt.numduplicates;  //a node has

			if (tempt.isIntermediate == false)
			{
				dups++;
				inter = 0;
			}
			else
			{
				dups = 0;
				inter = 1;
			}

			tempNL = new NameList(tempt.name, 0, dups, inter, i);
			namel.addElement(tempNL);
			i++;
		}

		//printnames();
		//set up the first level links
		/////////////links for all the just one nbors nodes/////////////////////
		i = 0;

		while (i < num2)
		{
			tempt = (TaxaItem) dnac.alltaxa.elementAt(i);
			num = tempt.nbor.size();

			if (num == 1)
			{
				tempNL = (NameList) namel.elementAt(i);
				nboritem = (TaxaItem) tempt.nbor.elementAt(0);
				j = 0;

				while (j < num2)
				{
					tempNL2 = (NameList) namel.elementAt(j);

					if (nboritem.name == tempNL2.name)
					{

						if (tempNL2.groupID == 0)
						{  //nbor not in a group

							tempLL = new LinkList(group, level, levelid);
							tempname = new NameList(tempNL.name, i, tempNL.indivs, tempNL.inter, tempNL.pos);
							tempLL.names.addElement(tempname);
							tempLL.members = 1;
							tempt2 = (TaxaItem) dnac.alltaxa.elementAt(j);
							num3 = tempt2.nbor.size();
							tempLL.nbors = num + num3;
							tempLL.numindiv = tempLL.numindiv + tempname.indivs;

							//printMembers(tempLL);
							tempname = new NameList(tempNL2.name, j, tempNL2.indivs, tempNL2.inter, tempNL2.pos);
							tempLL.names.addElement(tempname);
							tempLL.members = 2;
							tempLL.numindiv = tempLL.numindiv + tempname.indivs;

							//printMembers(tempLL);
							linkl.addElement(tempLL);

							//printgroups(group+1);
							tempNL.groupID = group;
							tempNL2.groupID = group;

							//add modified nbor back
							namel.insertElementAt(tempNL2, j);
							tempN1 = (NameList) namel.elementAt(j);
							tempN2 = (NameList) namel.elementAt(j + 1);

							//printnames();
							if (tempN1.name == tempN2.name)
							{

								//dprintln("insert pushes all down one for j");
								namel.removeElementAt(j + 1);

								//printnames();
							}

							levelid++;
							group++;

							//dprintln("group value: "+ group);
							//printgroups(group);
						}
						else
						{  //nbor2 in a group already

							gr = tempNL2.groupID - 1;
							{
								tempLL = (LinkList) linkl.elementAt(gr);

								if (tempLL.groupID == tempNL2.groupID)
								{
									tempname = new NameList(tempNL.name, i, tempNL.indivs, tempNL.inter, tempNL.pos);  //this may cause a problem
									tempLL.names.addElement(tempname);
									tempLL.members++;
									tempLL.nbors += num;
									tempLL.numindiv = tempLL.numindiv + tempname.indivs;

									//printMembers(tempLL);
									linkl.insertElementAt(tempLL, gr);
									tempL1 = (LinkList) linkl.elementAt(gr);
									tempL2 = (LinkList) linkl.elementAt(gr + 1);

									//printnames();
									if (tempL2.groupID == tempL1.groupID)
									{

										//dprintln("insert push all down one for gr");
										linkl.removeElementAt(gr + 1);

										//printnames();
									}

									tempNL.groupID = tempLL.groupID;
									gr = gnum;

									//printgroups(group);
								}

								gr++;
							}
						}  //end else nbor already in group

						//add modified original back into the list
						namel.insertElementAt(tempNL, i);
						tempN1 = (NameList) namel.elementAt(i);
						tempN2 = (NameList) namel.elementAt(i + 1);

						//printnames();
						if (tempN1.name == tempN2.name)
						{

							//dprintln("insert pushes all down one for i");
							namel.removeElementAt(i + 1);

							//printnames();
						}

						j = num2;
					}  //close if nbor found

					j++;
				}  //close while j
			}  //close if 1 nbor

			i++;
		}  //close while i

		/////////////////end of pass one for one nbors/////////////////////////////
		//		dprintln("\rAfter pass one \r");

		//printnames();
		//printgroups(group);
		//////////pass two add those with more than one nbor//////////////////////
		int notgroup       = 1;
		int nextlayer      = 0;
		int orderSize      = 0;
		int nbornum        = 0;
		int indivNum1      = 0;
		int indivNum2      = 0;
		int thegroupID     = 0;
		int thenumIndiv    = 0;
		int thepos         = 0;
		num3 = 0;

		while (notgroup == 1)
		{
			i = 0;
			num = 0;

			//notgroup = 0;
			///want to put a layer creation list loop here
			orderSize = 0;
			orderName = new Vector();
			orderSize = orderName.size();

			if (orderSize > 0)
			{
				dprintln("This vector is not empty.  It has : " + orderSize + "elements", 0x90);
			}

			//printgroups(group);
			dprintln("\r This is new loop \r", 0x90);

			//I will go through this loop multiple times
			//I will work in one level each time
			while (i < num2)
			{  //add nodes that don't have first level links

				tempt = (TaxaItem) dnac.alltaxa.elementAt(i);
				num = tempt.nbor.size();

				if (num > 1)
				{
					tempNL = (NameList) namel.elementAt(i);
					dprintln("name of node: " + tempNL.name, 0x90);

					if (tempNL.groupID == 0)
					{  //node not in group

						j = 0;
						nextlayer = 0;
						dprintln("name with 0 groupID: " + tempNL.name, 0x90);

						//check to see if the node is next layer in
						while (j < num)
						{  //go through all nbors

							nboritem = (TaxaItem) tempt.nbor.elementAt(j);
							nl = 0;

							while (nl < num2)
							{  //find nbor in namelist

								tempNL2 = (NameList) namel.elementAt(nl);

								if (tempNL2.name == nboritem.name)
								{
									nl = num2;  //don't search through more of the list nbor found

									if (tempNL2.groupID != 0)
									{  //found a nbor w/ gr nextlayer =1

										j = num;  //don't look at more nbors this node is next level
										dprintln("found nbor: " + tempNL2.name + " in groupid " + tempNL2.groupID, 0x90);

										if (orderSize == 0)
										{  //first namelist,nextlayer

											dprintln(tempNL.name + " is the first entry in my order list", 0x90);
											orderName.addElement(tempNL);
											orderSize++;
										}
										else if (tempNL.inter == 1)
										{  //intermediates nextlayer add at end of list

											dprintln(tempNL.name + " is an inter add to end of list", 0x90);
											orderName.addElement(tempNL);
											orderSize++;
										}
										else
										{  //nextlayer namelists add in order of # of nbors

											orderSize = orderName.size();

											for (int m = 0; m < orderSize; m++)
											{
												tempNL3 = (NameList) orderName.elementAt(m);
												tempt2 = (TaxaItem) dnac.alltaxa.elementAt(tempNL3.pos);
												nbornum = tempt2.nbor.size();

												if (nbornum == num)
												{
													indivNum1 = tempNL.indivs;
													indivNum2 = tempNL3.indivs;
													dprintln(indivNum1 + " # of tempNL.indivs and " + indivNum2 + " of tempNL3.indivs", 0x90);

													if (indivNum2 > indivNum1)
													{  //more individuals same # of links goes latter

														dprintln(tempNL.name + " was inserted before " + tempNL3.name, 0x90);
														orderName.insertElementAt(tempNL, m);

														//orderSize++;
														m = orderSize;
													}
													else if (m + 1 == orderSize)
													{
														dprintln(tempNL.name + " has more indiv add at end " + tempNL3.name, 0x90);
														orderName.addElement(tempNL);

														//orderSize++;
														m = orderSize++;
													}
												}
												else if (nbornum > num)
												{

													//insert a node in orderlist here and push the greater ones down one
													dprintln(tempNL.name + " has less nbors insert before " + tempNL3.name, 0x90);
													orderName.insertElementAt(tempNL, m);
													orderSize++;
													m = orderSize++;
												}
												else if (m + 1 == orderSize)
												{
													dprintln(tempNL.name + " has more nbor add at end " + tempNL3.name, 0x90);
													orderName.addElement(tempNL);
													orderSize++;
													m = orderSize++;
												}
											}
										}

										/*
											 nextlayer = 1;
											 nl = num2;
											 j = num;
										 */
										dprintln(tempNL.name + " has nbor: " + tempNL2.name + " in group: " + tempNL2.groupID, 0x90);
									}  //end in a group
								}  //end if nbor == namelist

								nl++;
							}  //end name list search

							j++;
						}  //end nbor list search while j<num
					}  //end if not in group groupid=0
				}  //end if num > 1

				i++;
			}  //end go through the whole list i<num2

			i = 0;
			num3 = orderName.size();

			if (num3 > 0)
			{

				while (i < num3)
				{
					tempNL = (NameList) orderName.elementAt(i);
					tempt = (TaxaItem) dnac.alltaxa.elementAt(tempNL.pos);
					num = tempt.nbor.size();
					dprintln(tempNL.name + " has " + num + " # of nbors", 0x90);
					tempNL3 = (NameList) namel.elementAt(tempNL.pos);

					if (tempNL3.groupID == 0)
					{
						j = 0;
						grsize = big;
						grindiv = big;
						thegroupID = big;
						thenumIndiv = big;

						while (j < num)
						{  //go through all nbors

							nboritem = (TaxaItem) tempt.nbor.elementAt(j);
							dprintln(nboritem.name + " is a nbor", 0x90);
							nl = 0;

							while (nl < num2)
							{  //find nbor in namelist

								tempNL2 = (NameList) namel.elementAt(nl);

								if (tempNL2.name == nboritem.name)
								{
									dprintln(nboritem.name + " has found its location", 0x90);

									if (tempNL2.groupID == 0)
									{  //found a nbor w/out gr create group

										dprintln(tempNL2.name + " is not a member of a group", 0x90);

										if (thenumIndiv > tempNL2.indivs)
										{
											dprintln(tempNL2.name + " has " + tempNL2.indivs + " # of indivs", 0x90);
											thegroupID = 0;
											thenumIndiv = tempNL2.indivs;
											thepos = nl;
										}
									}
									else if (thegroupID != 0)
									{  //found a nbor in group take size

										dprintln(tempNL2.name + " has a groupid " + tempNL2.groupID, 0x90);
										gr = tempNL2.groupID - 1;
										tempLL = (LinkList) linkl.elementAt(gr);

										if (tempLL.groupID == tempNL2.groupID)
										{  //found group

											//dprintln("found the correct group");
											dprintln(tempLL.numindiv + " is # of group indiv ", 0x90);
											dprintln(grindiv + " is # of current best indiv ", 0x90);

											if (tempLL.numindiv < grindiv)
											{  //a smaller group

												dprintln(tempLL.groupID + " is smallest group indiv size: " + tempLL.numindiv, 0x90);
												grindiv = tempLL.numindiv;
												grsize = tempLL.members;
												grID = tempLL.groupID;
												grPos = gr;
											}
										}  //end if id==
									}  //end else if thegroupID !=0

									nl = num2;
								}  //end if name == name

								nl++;
							}  //end while nl<num2

							j++;
						}  //end while j gone through all the nbors.

						if (thegroupID == 0)
						{  //found a nbor w/out gr create group

							dprintln("this is a new group created for", 0x90);
							tempNL2 = (NameList) namel.elementAt(thepos);
							dprintln(tempNL.name, 0x90);  //this I want with,0x90
							dprintln(tempNL2.name, 0x90);  //this I want with ,0x90
							tempLL = new LinkList(group, level, levelid);
							tempname = new NameList(tempNL.name, tempNL.pos, tempNL.indivs, tempNL.inter, tempNL.pos);  //this may cause a problem
							tempLL.names.addElement(tempname);
							tempLL.numindiv = tempNL.indivs + tempNL2.indivs;
							tempname = new NameList(tempNL2.name, thepos, tempNL2.indivs, tempNL2.inter, tempNL2.pos);  //this may cause a problem
							tempLL.names.addElement(tempname);
							tempLL.members = 2;
							tempt2 = (TaxaItem) dnac.alltaxa.elementAt(tempNL2.pos);
							num3 = tempt2.nbor.size();
							tempLL.nbors = num + num3;

							//add new group to LinkList
							linkl.addElement(tempLL);
							tempNL.groupID = group;
							tempNL2.groupID = group;

							//add modified nbor back
							namel.insertElementAt(tempNL2, thepos);
							tempN1 = (NameList) namel.elementAt(thepos);
							tempN2 = (NameList) namel.elementAt(thepos + 1);

							if (tempN1.name == tempN2.name)
							{

								//dprintln("insert pushes all down one for nl");
								namel.removeElementAt(thepos + 1);
							}

							levelid++;
							group++;
						}
						else if (thegroupID != 0)
						{

							//set it to the smallest grsize
							dprintln(tempNL.name + " is being added to group: " + grID, 0x90);
							tempNL.groupID = grID;
							tempLL = (LinkList) linkl.elementAt(grPos);
							tempname = new NameList(tempNL.name, tempNL.pos, tempNL.indivs, tempNL.inter, tempNL.pos);  //this may cause a problem
							tempLL.names.addElement(tempname);
							tempLL.members++;
							tempLL.nbors += num;
							tempLL.numindiv = tempLL.numindiv + tempNL.indivs;

							//add modified group back
							linkl.insertElementAt(tempLL, grPos);
							tempL1 = (LinkList) linkl.elementAt(grPos);
							tempL2 = (LinkList) linkl.elementAt(grPos + 1);

							if (tempL2.groupID == tempL1.groupID)
							{

								//dprintln("insert push all down one for gr");
								linkl.removeElementAt(grPos + 1);
							}
						}

						//add modified node back
						namel.insertElementAt(tempNL, tempNL.pos);
						tempN1 = (NameList) namel.elementAt(tempNL.pos);
						tempN2 = (NameList) namel.elementAt(tempNL.pos + 1);

						if (tempN1.name == tempN2.name)
						{

							//dprintln("insert pushes all down one for i");
							namel.removeElementAt(tempNL.pos + 1);
						}
					}  //end if tempNL3.groupID == 0

					i++;
				}  //end while i<num3
			}  //end if num3 > 0;
			else
			{
				notgroup = 0;
			}
		}  //end while not group

		/////////////end of pass two all have level one now////////////////////
		//		dprintln("\rAfter pass two \r\n");

		//printnames();
		//printgroups(group);
		sortByNbor(0);

		///////////set up the grand loop to do the multilevel link list//////
		int gsrt           = 0;
		num3 = 0;

		int trys           = 1;
		int found          = 0;
		int glast          = 0;
		int match          = 0;
		int tempos         = 0;

		while (trys < LEVELS)
		{  //(levelid > 2) //until they are all in one group

			dprintln("Level: " + (trys + 1), 0x90);
			levelid = 1;
			level++;
			gnum = group;
			i = gsrt;
			sortByNbor(i);

			//printgroups(group);
			dprintln("group number = " + group, 0x90);

			if (glast == group)
			{
				dprintln("no change since the last round terminate", 0x90);
				i = gnum;
				//				System.out.println("It hasn't changed at level " + trys + "group = " + group);
				// how do I know how many are in this group?  if it is > 1 then it should be the answer...
				trys = LEVELS;
			}

			glast = group;

			while (i < gnum - 1)
			{  //loop through groups, the -1 may be wrong

				tempLL = (LinkList) linkl.elementAt(i);

				if ((tempLL.level == (level - 1)) && (tempLL.nextlevel == 0))
				{  //only look at groups from last level

					j = 0;
					num = tempLL.names.size();
					dprintln(tempLL.groupID + " group trying to join", 0x90);
					grsize = big;
					found = 0;

					while (j < num)
					{  //loop through all names in group

						tempNL = (NameList) tempLL.names.elementAt(j);
						tempt = (TaxaItem) dnac.alltaxa.elementAt(tempNL.pos);
						num3 = tempt.nbor.size();

						if (num3 > 1)
						{  //has more than one nbor

							dprintln(tempt.name + " the number of nbors = " + num3, 0x90);

							for (int k = 0; k < num3; k++)
							{  //check all nbors

								nboritem = (TaxaItem) tempt.nbor.elementAt(k);
								nl = 0;
								dprintln("looking for nbor name = " + nboritem.name, 0x90);

								while (nl < num2)
								{  //find nbor in namelist

									tempNL2 = (NameList) namel.elementAt(nl);

									if (tempNL2.name == nboritem.name)
									{  //find the correct namelist node

										dprintln("found nbor name = " + tempNL2.name, 0x90);

										if (tempNL2.groupID != tempLL.groupID)
										{  //make sure nbor not same group

											dprintln(" ************** for group id = " + tempLL.groupID, 0x90);
											match = 0;
											tempL1 = (LinkList) linkl.elementAt(0);

											for (int t = gsrt; t < group; t++)
											{
												tempL1 = (LinkList) linkl.elementAt(t);
												dprintln("1st gId = " + tempNL2.groupID + " 2nd gID = " + tempL1.groupID, 0x90);

												if (tempNL2.groupID == tempL1.groupID)
												{
													tempos = t;
													t = group;
													match = 1;
												}
											}

											if (match == 1)
											{
												dprintln("group " + tempL1.groupID + " indiv " + tempL1.numindiv, 0x90);

												if (((tempL1.numindiv < grsize) &&
														(tempL1.nextlevel == 0)) ||
														((tempL1.numindiv == grsize) &&
														(tempL1.groupID < grID)))
												{  //a smaller group & not combined

													dprintln("found small group: " + tempL1.groupID + " indiv = " + tempL1.numindiv, 0x90);
													found = 1;
													grsize = tempL1.numindiv;
													grID = tempL1.groupID;
													grPos = tempos;
												}  //end of small group size if
											}
										}  //end of !=id's if

										nl = num2;
									}  //end of if nbor.name==namelist.name

									nl++;
								}  //end of while n1<num2
							}  //end for k
						}  //end if num3>1

						j++;
					}  //end of j<num while

					//we have left the upper 2 loops and found the smallest nbor group
					if (found == 1)
					{  //this only allows in if found a small group to combine

						tempL1 = (LinkList) linkl.elementAt(grPos);

						if (tempL1.level == (level - 1))
						{  //the small group is level-1

							//dprintln("found small group level - 1");
							tempL2 = new LinkList(group, level, levelid);
							tempL2.list.addElement(tempLL);
							tempL2.list.addElement(tempL1);
							tempL2.nbors = tempLL.nbors + tempL1.nbors;
							j = 0;

							while (j < num)
							{  //loop through all the names in cur group

								tempNL = (NameList) tempLL.names.elementAt(j);
								nl = tempNL.groupID;
								tempname = new NameList(tempNL.name, nl, tempNL.indivs, tempNL.inter, tempNL.pos);
								tempL2.names.addElement(tempname);  //add namelist to names
								tempNL2 = (NameList) namel.elementAt(nl);
								tempNL2.groupID = group;  //update name1 groupid
								namel.insertElementAt(tempNL2, nl);
								tempN1 = (NameList) namel.elementAt(nl);
								tempN2 = (NameList) namel.elementAt(nl + 1);

								if (tempN1.name == tempN2.name)
								{

									//dprintln("insert pushes all down one for nl");
									namel.removeElementAt(nl + 1);
								}

								j++;
							}

							j = 0;

							while (j < tempL1.members)
							{  //loop through all the names in small group

								tempNL = (NameList) tempL1.names.elementAt(j);
								nl = tempNL.groupID;
								tempname = new NameList(tempNL.name, tempNL.groupID, tempNL.indivs, tempNL.inter, tempNL.pos);
								tempL2.names.addElement(tempname);  //add namelist to names
								tempNL2 = (NameList) namel.elementAt(nl);
								tempNL2.groupID = group;  //update name1 groupid
								namel.insertElementAt(tempNL2, nl);
								tempN1 = (NameList) namel.elementAt(nl);
								tempN2 = (NameList) namel.elementAt(nl + 1);

								if (tempN1.name == tempN2.name)
								{

									//dprintln("insert pushes all down one for nl");
									namel.removeElementAt(nl + 1);
								}

								j++;
							}

							tempLL.nextlevel = 1;
							linkl.insertElementAt(tempLL, i);  //replace current group
							tempL3 = (LinkList) linkl.elementAt(i);
							tempL4 = (LinkList) linkl.elementAt(i + 1);

							if (tempL3.groupID == tempL4.groupID)
							{

								//dprintln("insert push all down one for gr");
								linkl.removeElementAt(i + 1);
							}

							tempL1.nextlevel = 1;
							linkl.insertElementAt(tempL1, grPos);  //replace the adjoining group
							tempL3 = (LinkList) linkl.elementAt(grPos);
							tempL4 = (LinkList) linkl.elementAt(grPos + 1);

							if (tempL3.groupID == tempL4.groupID)
							{

								//dprintln("insert push all down one for gr");
								linkl.removeElementAt(grPos + 1);
							}

							tempL2.numindiv = tempL1.numindiv + tempLL.numindiv;
							tempL2.members = tempLL.members + tempL1.members;
							linkl.addElement(tempL2);  //add new group
							group++;
							dprintln("newgroup = " + group, 0x90);
							levelid++;

							//printgroups2(group,gnum-1);
						}  //end level == level-1 if
						else if (tempL1.level == level)
						{  //the small group is level

							//dprintln("found small group level = level");
							j = 0;

							while (j < num)
							{  //loop through all the names in cur group

								tempNL = (NameList) tempLL.names.elementAt(j);
								nl = tempNL.groupID;
								tempname = new NameList(tempNL.name, nl, tempNL.indivs, tempNL.inter, tempNL.pos);
								tempL1.names.addElement(tempname);  //add namelist to names
								tempNL2 = (NameList) namel.elementAt(nl);
								tempNL2.groupID = tempL1.groupID;  //update name1 groupid
								namel.insertElementAt(tempNL2, nl);
								tempN1 = (NameList) namel.elementAt(nl);
								tempN2 = (NameList) namel.elementAt(nl + 1);

								if (tempN1.name == tempN2.name)
								{

									//dprintln("insert pushes all down one for nl");
									namel.removeElementAt(nl + 1);
								}

								j++;
							}

							tempL1.list.addElement(tempLL);
							tempL1.nbors += tempLL.nbors;
							tempLL.nextlevel = 1;
							linkl.insertElementAt(tempLL, i);  //replace current group
							tempL3 = (LinkList) linkl.elementAt(i);
							tempL4 = (LinkList) linkl.elementAt(i + 1);

							if (tempL3.groupID == tempL4.groupID)
							{

								//dprintln("insert push all down one for gr");
								linkl.removeElementAt(i + 1);
							}

							tempL1.members = tempLL.members + tempL1.members;
							tempL1.numindiv = tempLL.numindiv + tempL1.numindiv;
							tempL1.nextlevel = 0;
							linkl.insertElementAt(tempL1, grPos);  //replace the concatenated group
							tempL3 = (LinkList) linkl.elementAt(grPos);
							tempL4 = (LinkList) linkl.elementAt(grPos + 1);

							if (tempL3.groupID == tempL4.groupID)
							{

								//dprintln("insert push all down one for gr");
								linkl.removeElementAt(grPos + 1);
							}

							//printgroups2(group,gnum-1);
						}  //end else if small.level == level
						else
						{
							dprintln("there is a real problem with group choice");
							dprintln("level of group: " + tempL1.level);
							dprintln("groupID: " + tempL1.level);
							dprintln("This is the current level" + level);
							printMembers(tempL1);
						}

						//printgroups(group);
					}  //end if found == 1
				}  //end the level==level if

				i++;
			}  //end the gnum while

			gsrt = gnum - 1;
			trys++;
		}  //end the levelid while

		/////////end of creating all the levels lists/////////////////////////
		////////print out of all nodes in each list///////////////////////////
		dprintln("\rend of all levels \r\n", 0x90);

		//printnames();
		printgroups(group);
		dprintln("group = " + group, 0x01);

		/*
			 tempL1 = (LinkList)linkl.elementAt(group-2);
			 int thelevel = tempL1.level;
		 */
		int tlev           = 0;
		i = 2;

		while ((group - i) > -1)
		{  //tlev == thelevel)

			tempL1 = (LinkList) linkl.elementAt(group - i);
			tlev = tempL1.level;
			dprintln("the level = " + tempL1.level + "." + tempL1.levelID, 0x01);
			zooStyle(tempL1);
			dprintln("", 0x01);
			i++;
		}

		///////end of print out of all nodes in each list////////////////////
		////////////////////the loops below print out all nodes and there neighbors.

		/*i = 0;
			 num = 0;
			 while (i<num2)
					 {
				 tempt = (TaxaItem) dnac.alltaxa.elementAt(i);
						 num = tempt.nbor.size();
						 dprint(Integer.toString(tempt.id));//c1
				 dprintln(" nbor # of elements " + num);
				 j= 0;
				 while (j<num)
				 {
							 if (tempt.isIntermediate)
								 dprint("[" +tempt.name+"]  ");
							 else
				 dprint("["+tempt.name+"]  ");
			 dprint("  :");
			 tempitem = (TaxaItem) tempt.nbor.elementAt(j);
			 if (tempitem.isIntermediate)
								 dprint("[" +tempitem.name+"]  ");
							 else
				 dprint(" " + tempitem.name + " ");
			 dprintln("");
			 j++;
				 }
				 i++;
				 dprintln("");//\r
			 }*/
		/*  i=0;
			 while (i<num2)
					 {
				 tempt = (TaxaItem) dnac.alltaxa.elementAt(i);
				 dprint("["+tempt.name+"]  ");
				 dprint(Integer.toString(tempt.id));//c1
				 dprint("  : ");
				 dprint(String.valueOf(tempt.characters));
				 dprintln("");
				 i++;
			 }*/
		///////////end of printing out all nodes and there neighbors/////////
	}  //end of run function.


	public void zooStyle(LinkList tlist)
	{
		dprint("(", 0x01);

		LinkList list2;
		int tsize       = tlist.list.size();
		NameList nlist;

		if (tsize == 0)
		{

			for (int i = 0; i < tlist.members; i++)
			{
				nlist = (NameList) tlist.names.elementAt(i);
				dprint(nlist.name + "", 0x01);

				if (i + 1 < tlist.members)
				{
					dprint(",", 0x01);
				}
			}
		}
		else
		{

			for (int i = 0; i < tsize; i++)
			{
				list2 = (LinkList) tlist.list.elementAt(i);
				zooStyle(list2);

				if (i + 1 < tsize)
				{
					dprint(",", 0x01);
				}
			}
		}

		dprint(")", 0x01);
	}


	public void sortByNbor(int start)
	{

		int i           = 0;
		int j           = 0;
		LinkList temp1;
		LinkList temp2;
		int total       = linkl.size();
		dprintln("linkl size = " + total, 0x80);

		int total2      = total - 1;

		for (i = start; i < total; i++)
		{
			dprintln("++++++++++ i = " + i, 0x80);
			temp1 = (LinkList) linkl.elementAt(start);
			linkl.removeElementAt(start);

			for (j = start; j < total2; j++)
			{
				temp2 = (LinkList) linkl.elementAt(j);
				linkl.removeElementAt(j);
				dprintln("temp1 " + temp1.level + "." + temp1.levelID, 0x80);
				dprintln("temp2 " + temp2.level + "." + temp2.levelID, 0x80);

				if (temp1.nbors <= temp2.nbors)
				{
					dprintln("temp1 " + temp1.level + "." + temp1.levelID + " is placed " + j, 0x80);
					linkl.insertElementAt(temp1, j);
					temp1 = temp2;
				}
				else
				{
					dprintln("temp2 " + temp2.level + "." + temp2.levelID + " is placed at " + j, 0x80);
					linkl.insertElementAt(temp2, j);
				}
			}

			dprintln("temp1 " + temp1.level + "." + temp1.levelID + " is placed " + total2, 0x80);
			linkl.insertElementAt(temp1, (j));
			total2--;
			total--;

			//printgroups(size+1);
		}
	}

//	public void printgroups2(int group, 													 int start)
//	{
//
//		int      i;
//		LinkList tempL1;
//
//		for (i = start; i < group - 1; i++)
//		{
//			tempL1 = (LinkList) linkl.elementAt(i);
//			System.out.println("group: " + tempL1.level + "." + tempL1.levelID);
//			System.out.println("there are " + linkl.size() + " members of this group...");
//			dprintln("group: " + tempL1.level + "." + tempL1.levelID);
//
//			dprintln("# of members: " + tempL1.members);
//			printMembers(tempL1);
//
//			/*for (j=0;j<tempL1.members;j++)
//				 {
//					 tempN1 = (NameList)tempL1.names.elementAt(j);
//					 dprintln(tempN1.name +" "+ tempN1.groupID);
//				 }*/
//			dprintln("groupID: " + tempL1.groupID);
//			dprintln("nextlevel: " + tempL1.nextlevel);
//			dprintln("");
//		}
//	}

	public void printgroups(int group)
	{

		int i;
		LinkList tempL1;

		for (i = 0; i < group - 1; i++)
		{
			tempL1 = (LinkList) linkl.elementAt(i);
//			System.out.println("group: " + tempL1.level + "." + tempL1.levelID);
//			System.out.println("there are " + linkl.size() + " members of this group...");
			dprintln("group: " + tempL1.level + "." + tempL1.levelID);
			dprintln("# of members: " + tempL1.members);
			dprintln("# of indivs: " + tempL1.numindiv);
			dprintln("# of nbors: " + tempL1.nbors);

			if (tempL1.list.size() == 0)
			{
				printMembers(tempL1);
			}
			else
			{
				printSubg(tempL1);
			}

			//dprintln("groupID: "+ tempL1.groupID);
			//dprintln("nextlevel: "+ tempL1.nextlevel);
			dprintln("");
		}
	}


	public void printSubg(LinkList tempL)
	{

		int tsize       = tempL.list.size();
		LinkList temp2;

		for (int i = 0; i < tsize; i++)
		{
			temp2 = (LinkList) tempL.list.elementAt(i);
			dprintln("group " + temp2.level + "." + temp2.levelID, 0x01);
		}
	}


	public void printnames()
	{

		int i;
		NameList tempN1;
		int num          = namel.size();
		dprintln("NameList:");

		for (i = 0; i < num; i++)
		{
			tempN1 = (NameList) namel.elementAt(i);
			dprintln(tempN1.name + " " + tempN1.groupID);
		}

		dprintln("");
	}


	public void printMembers(LinkList tempLL)
	{
		int i;
		NameList tempNl;
		dprintln("members:");

		for (i = 0; i < tempLL.members; i++)
		{
			tempNl = (NameList) tempLL.names.elementAt(i);
			dprintln(tempNl.name);  //+" groupid: "+ tempNl.groupID);
		}
	}


	public void dprintln(String str, int level)
	{

		if ((debug & level) != 0)
		{
			logfile.println(str);
		}
	}


	public void dprintln(String str)
	{

		if (debug != 0)
		{
			logfile.println(str);
		}
	}


	public void dprint(String str, int level)
	{

		if ((debug & level) != 0)
		{
			logfile.print(str);
		}
	}


	public void dprint(String str)
	{

		if (debug != 0)
		{
			logfile.print(str);
		}
	}
}  //end of the nesting class
