package EDU.auburn.VGJ.nesting;
/*created sept 11, 2000
 *by Jake Derington
 *
*/

import java.awt.Dialog;
   import java.awt.Button;
   import java.awt.Frame;
   import java.awt.Event;
   import java.awt.TextField;
   import java.awt.FileDialog;
   import java.awt.Checkbox;
   import java.io.PrintStream;
   import java.io.FileOutputStream;
   import java.io.IOException;
   import java.io.File;
   import java.lang.Process;
   import java.lang.Runtime;
   import java.lang.Exception;
   import EDU.auburn.VGJ.graph.Graph;
		import java.io.DataOutputStream;
		import EDU.auburn.VGJ.gui.*;
		import clad.*;

public class NestDialog extends Dialog
{
		private Graph graph_;
	  private GraphCanvas graphCanvas_;
	  private Frame frame_;

	  private TextField width_, height_, pointSize_, margin_,
	  		pWidth_, pHeight_, overlap_, printCmd_;
	  private Checkbox landscape_;
		public dna dnac;

	public NestDialog(Frame frame, GraphCanvas graph_canvas,dna tdna)
	{		
		super(frame, "Cladograph nesting", false);
		System.out.println("this is nestdialog");
		dnac =tdna;
		graphCanvas_ = graph_canvas;
		frame_ = frame;
		LPanel p = new LPanel();
		p.addLineLabel("This will execute the nesting procedure of the cladogram", 0);
		p.addButtonPanel("Level-1 Level-2 Level-3 Level-4 Level-5 Level-6 Level-7 Level-8 Level-9 Level-10 Close", 0);
		p.finish();
		add("Center", p);
		pack();
		show();
	}

	public boolean action(Event event, Object object) {
		if (event.target instanceof Button)
		{

			if ("Close".equals(object))
			{
				hide();
				System.out.println("this is the close function");
			}
			else if ("Level-1".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(1);
			}
                        else if ("Level-2".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(2);
			}
                        else if ("Level-3".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(3);
			}
                        else if ("Level-4".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(4);
			}
                        else if ("Level-5".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(5);
			}
			else if ("Level-6".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(6);
			}
			else if ("Level-7".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(7);
			}
			else if ("Level-8".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(8);
			}
			else if ("Level-9".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(9);
			}
			else if ("Level-10".equals(object))
			{
				System.out.println("this is the execute function");
				Nesting nest = new Nesting(dnac);
				nest.run(10);
			}
		}

		return false;
	}

	public boolean handleEvent(Event event)
	{
	 // Avoid having everything destroyed.
		 if (event.id == Event.WINDOW_DESTROY)
		 {
			hide();
			return true;
		 }
		 return super.handleEvent(event);
	}
}

